#include "stdafx.h"

BALL::BALL(int X, int Y, int R, COLORREF C)
{
	x=X; y=Y; 
	r=R;
	b=CreateSolidBrush(C);
	u=rand()%9-4; v=rand()%9-4;
}

BALL::~BALL()
{
	DeleteObject(b);
}

void BALL::Step(RECT &R)
{
	x+=u; y+=v;
	if (x-r<0) u=abs(u);
	if (y-r<0) v=abs(v);
	if (x+r>R.right ) u=-abs(u);
	if (y+r>R.bottom) v=-abs(v);
}

void BALL::Paint(HDC hdc)
{   HBRUSH old = (HBRUSH) SelectObject(hdc,b);
	Ellipse(hdc,x-r,y-r,x+r,y+r);
	SelectObject(hdc,old);
}

// =========  BALLS ====================

BALLS::BALLS(int MAX)
{
	p=new PBALL[Max=MAX];
	n=0;
}

BALLS::~BALLS()
{
	while (Del());
	delete p;
}

bool BALLS::Add(int X, int Y, int R, COLORREF C)
{
   if (n<Max)
   {
	   p[n++]=new BALL(X,Y,R,C);
	   return true;
   }
   else return false;
}

bool BALLS::Del()
{
	if (n>0)
	{
		delete p[--n];
		return true;
	}
	else return false;
}

void BALLS::Step(RECT &R)
{
	for (int i=0; i<n; i++) p[i]->Step(R);
}

void BALLS::Paint(HDC hdc)
{
	for (int i=0; i<n; i++) p[i]->Paint(hdc);
}
